#include <mpi.h>

// Load-time constants
int MPICONSTANTS_ANY_SOURCE;
int MPICONSTANTS_ANY_TAG;
int MPICONSTANTS_PROC_NULL;
int MPICONSTANTS_ROOT;
int MPICONSTANTS_CART;
int MPICONSTANTS_DIST_GRAPH;
int MPICONSTANTS_GRAPH;
int MPICONSTANTS_CONGRUENT;
int MPICONSTANTS_IDENT;
int MPICONSTANTS_SIMILAR;
int MPICONSTANTS_UNEQUAL;
int MPICONSTANTS_BSEND_OVERHEAD;
int MPICONSTANTS_KEYVAL_INVALID;
int MPICONSTANTS_UNDEFINED;
int MPICONSTANTS_APPNUM;
int MPICONSTANTS_HOST;
int MPICONSTANTS_IO;
int MPICONSTANTS_LASTUSEDCODE;
int MPICONSTANTS_TAG_UB;
int MPICONSTANTS_UNIVERSE_SIZE;
int MPICONSTANTS_WIN_BASE;
int MPICONSTANTS_WIN_CREATE_FLAVOR;
int MPICONSTANTS_WIN_DISP_UNIT;
int MPICONSTANTS_WIN_MODEL;
int MPICONSTANTS_WIN_SIZE;
int MPICONSTANTS_WTIME_IS_GLOBAL;
int MPICONSTANTS_COMBINER_CONTIGUOUS;
int MPICONSTANTS_COMBINER_DARRAY;
int MPICONSTANTS_COMBINER_DUP;
int MPICONSTANTS_COMBINER_F90_COMPLEX;
int MPICONSTANTS_COMBINER_F90_INTEGER;
int MPICONSTANTS_COMBINER_F90_REAL;
int MPICONSTANTS_COMBINER_HINDEXED;
int MPICONSTANTS_COMBINER_HINDEXED_BLOCK;
int MPICONSTANTS_COMBINER_HVECTOR;
int MPICONSTANTS_COMBINER_INDEXED;
int MPICONSTANTS_COMBINER_INDEXED_BLOCK;
int MPICONSTANTS_COMBINER_NAMED;
int MPICONSTANTS_COMBINER_RESIZED;
int MPICONSTANTS_COMBINER_STRUCT;
int MPICONSTANTS_COMBINER_SUBARRAY;
int MPICONSTANTS_COMBINER_VECTOR;
int MPICONSTANTS_COMM_TYPE_SHARED;
int MPICONSTANTS_DISTRIBUTE_BLOCK;
int MPICONSTANTS_DISTRIBUTE_CYCLIC;
int MPICONSTANTS_DISTRIBUTE_NONE;
int MPICONSTANTS_ERR_ACCESS;
int MPICONSTANTS_ERR_AMODE;
int MPICONSTANTS_ERR_ARG;
int MPICONSTANTS_ERR_ASSERT;
int MPICONSTANTS_ERR_BAD_FILE;
int MPICONSTANTS_ERR_BASE;
int MPICONSTANTS_ERR_BUFFER;
int MPICONSTANTS_ERR_COMM;
int MPICONSTANTS_ERR_CONVERSION;
int MPICONSTANTS_ERR_COUNT;
int MPICONSTANTS_ERR_DIMS;
int MPICONSTANTS_ERR_DISP;
int MPICONSTANTS_ERR_DUP_DATAREP;
int MPICONSTANTS_ERR_FILE;
int MPICONSTANTS_ERR_FILE_EXISTS;
int MPICONSTANTS_ERR_FILE_IN_USE;
int MPICONSTANTS_ERR_GROUP;
int MPICONSTANTS_ERR_INFO;
int MPICONSTANTS_ERR_INFO_KEY;
int MPICONSTANTS_ERR_INFO_NOKEY;
int MPICONSTANTS_ERR_INFO_VALUE;
int MPICONSTANTS_ERR_INTERN;
int MPICONSTANTS_ERR_IN_STATUS;
int MPICONSTANTS_ERR_IO;
int MPICONSTANTS_ERR_KEYVAL;
int MPICONSTANTS_ERR_LASTCODE;
int MPICONSTANTS_ERR_LOCKTYPE;
int MPICONSTANTS_ERR_NAME;
int MPICONSTANTS_ERR_NOT_SAME;
int MPICONSTANTS_ERR_NO_MEM;
int MPICONSTANTS_ERR_NO_SPACE;
int MPICONSTANTS_ERR_NO_SUCH_FILE;
int MPICONSTANTS_ERR_OP;
int MPICONSTANTS_ERR_OTHER;
int MPICONSTANTS_ERR_PENDING;
int MPICONSTANTS_ERR_PORT;
int MPICONSTANTS_ERR_QUOTA;
int MPICONSTANTS_ERR_RANK;
int MPICONSTANTS_ERR_READ_ONLY;
int MPICONSTANTS_ERR_REQUEST;
#if MPI_VERSION >= 3
int MPICONSTANTS_ERR_RMA_ATTACH;
#endif
int MPICONSTANTS_ERR_RMA_CONFLICT;
#if MPI_VERSION >= 3
int MPICONSTANTS_ERR_RMA_FLAVOR;
int MPICONSTANTS_ERR_RMA_RANGE;
int MPICONSTANTS_ERR_RMA_SHARED;
#endif
int MPICONSTANTS_ERR_RMA_SYNC;
int MPICONSTANTS_ERR_ROOT;
int MPICONSTANTS_ERR_SERVICE;
int MPICONSTANTS_ERR_SIZE;
int MPICONSTANTS_ERR_SPAWN;
int MPICONSTANTS_ERR_TAG;
int MPICONSTANTS_ERR_TOPOLOGY;
int MPICONSTANTS_ERR_TRUNCATE;
int MPICONSTANTS_ERR_TYPE;
int MPICONSTANTS_ERR_UNKNOWN;
int MPICONSTANTS_ERR_UNSUPPORTED_DATAREP;
int MPICONSTANTS_ERR_UNSUPPORTED_OPERATION;
int MPICONSTANTS_ERR_WIN;
int MPICONSTANTS_SUCCESS;
int MPICONSTANTS_LOCK_EXCLUSIVE;
int MPICONSTANTS_LOCK_SHARED;
int MPICONSTANTS_MODE_APPEND;
int MPICONSTANTS_MODE_CREATE;
int MPICONSTANTS_MODE_DELETE_ON_CLOSE;
int MPICONSTANTS_MODE_EXCL;
int MPICONSTANTS_MODE_NOCHECK;
int MPICONSTANTS_MODE_NOPRECEDE;
int MPICONSTANTS_MODE_NOPUT;
int MPICONSTANTS_MODE_NOSTORE;
int MPICONSTANTS_MODE_NOSUCCEED;
int MPICONSTANTS_MODE_RDONLY;
int MPICONSTANTS_MODE_RDWR;
int MPICONSTANTS_MODE_SEQUENTIAL;
int MPICONSTANTS_MODE_UNIQUE_OPEN;
int MPICONSTANTS_MODE_WRONLY;
int MPICONSTANTS_ORDER_C;
int MPICONSTANTS_ORDER_FORTRAN;
int MPICONSTANTS_SEEK_CUR;
int MPICONSTANTS_SEEK_END;
int MPICONSTANTS_SEEK_SET;
int MPICONSTANTS_THREAD_SINGLE;
int MPICONSTANTS_THREAD_FUNNELED;
int MPICONSTANTS_THREAD_SERIALIZED;
int MPICONSTANTS_THREAD_MULTIPLE;
int MPICONSTANTS_TYPECLASS_COMPLEX;
int MPICONSTANTS_TYPECLASS_INTEGER;
int MPICONSTANTS_TYPECLASS_REAL;

char **MPICONSTANTS_ARGV_NULL;
char ***MPICONSTANTS_ARGVS_NULL;
int *MPICONSTANTS_UNWEIGHTED;
int *MPICONSTANTS_WEIGHTS_EMPTY;
void *MPICONSTANTS_BOTTOM;
void *MPICONSTANTS_IN_PLACE;

MPI_Comm MPICONSTANTS_COMM_NULL;
MPI_Comm MPICONSTANTS_COMM_SELF;
MPI_Comm MPICONSTANTS_COMM_WORLD;
MPI_Comm_copy_attr_function *MPICONSTANTS_COMM_DUP_FN;
MPI_Comm_copy_attr_function *MPICONSTANTS_COMM_NULL_COPY_FN;
MPI_Comm_delete_attr_function *MPICONSTANTS_COMM_NULL_DELETE_FN;
MPI_Copy_function *MPICONSTANTS_NULL_COPY_FN;
MPI_Datatype MPICONSTANTS_2DOUBLE_PRECISION;
MPI_Datatype MPICONSTANTS_2INT;
MPI_Datatype MPICONSTANTS_2INTEGER;
MPI_Datatype MPICONSTANTS_2REAL;
MPI_Datatype MPICONSTANTS_AINT;
MPI_Datatype MPICONSTANTS_BYTE;
MPI_Datatype MPICONSTANTS_CHAR;
MPI_Datatype MPICONSTANTS_CHARACTER;
MPI_Datatype MPICONSTANTS_COMPLEX;
MPI_Datatype MPICONSTANTS_COMPLEX16;
#ifdef MPI_COMPLEX32
MPI_Datatype MPICONSTANTS_COMPLEX32;
#endif
MPI_Datatype MPICONSTANTS_COMPLEX8;
MPI_Datatype MPICONSTANTS_COUNT;
#if MPI_VERSION >= 3
MPI_Datatype MPICONSTANTS_CXX_BOOL;
MPI_Datatype MPICONSTANTS_CXX_DOUBLE_COMPLEX;
MPI_Datatype MPICONSTANTS_CXX_FLOAT_COMPLEX;
MPI_Datatype MPICONSTANTS_CXX_LONG_DOUBLE_COMPLEX;
#endif
MPI_Datatype MPICONSTANTS_C_BOOL;
MPI_Datatype MPICONSTANTS_C_COMPLEX;
MPI_Datatype MPICONSTANTS_C_DOUBLE_COMPLEX;
MPI_Datatype MPICONSTANTS_C_FLOAT_COMPLEX;
MPI_Datatype MPICONSTANTS_C_LONG_DOUBLE_COMPLEX;
MPI_Datatype MPICONSTANTS_DATATYPE_NULL;
MPI_Datatype MPICONSTANTS_DOUBLE;
MPI_Datatype MPICONSTANTS_DOUBLE_COMPLEX;
MPI_Datatype MPICONSTANTS_DOUBLE_INT;
MPI_Datatype MPICONSTANTS_DOUBLE_PRECISION;
MPI_Datatype MPICONSTANTS_FLOAT;
MPI_Datatype MPICONSTANTS_FLOAT_INT;
MPI_Datatype MPICONSTANTS_INT;
MPI_Datatype MPICONSTANTS_INT16_T;
MPI_Datatype MPICONSTANTS_INT32_T;
MPI_Datatype MPICONSTANTS_INT64_T;
MPI_Datatype MPICONSTANTS_INT8_T;
MPI_Datatype MPICONSTANTS_INTEGER;
MPI_Datatype MPICONSTANTS_INTEGER1;
MPI_Datatype MPICONSTANTS_INTEGER2;
MPI_Datatype MPICONSTANTS_INTEGER4;
MPI_Datatype MPICONSTANTS_INTEGER8;
MPI_Datatype MPICONSTANTS_LOGICAL;
MPI_Datatype MPICONSTANTS_LONG;
MPI_Datatype MPICONSTANTS_LONG_DOUBLE;
MPI_Datatype MPICONSTANTS_LONG_DOUBLE_INT;
MPI_Datatype MPICONSTANTS_LONG_INT;
MPI_Datatype MPICONSTANTS_LONG_LONG;
MPI_Datatype MPICONSTANTS_LONG_LONG_INT;
MPI_Datatype MPICONSTANTS_OFFSET;
MPI_Datatype MPICONSTANTS_PACKED;
MPI_Datatype MPICONSTANTS_REAL;
#ifdef MPI_REAL16
MPI_Datatype MPICONSTANTS_REAL16;
#endif
MPI_Datatype MPICONSTANTS_REAL4;
MPI_Datatype MPICONSTANTS_REAL8;
MPI_Datatype MPICONSTANTS_SHORT;
MPI_Datatype MPICONSTANTS_SHORT_INT;
MPI_Datatype MPICONSTANTS_SIGNED_CHAR;
MPI_Datatype MPICONSTANTS_UINT16_T;
MPI_Datatype MPICONSTANTS_UINT32_T;
MPI_Datatype MPICONSTANTS_UINT64_T;
MPI_Datatype MPICONSTANTS_UINT8_T;
MPI_Datatype MPICONSTANTS_UNSIGNED;
MPI_Datatype MPICONSTANTS_UNSIGNED_CHAR;
MPI_Datatype MPICONSTANTS_UNSIGNED_LONG;
MPI_Datatype MPICONSTANTS_UNSIGNED_LONG_LONG;
MPI_Datatype MPICONSTANTS_UNSIGNED_SHORT;
MPI_Datatype MPICONSTANTS_WCHAR;
MPI_Delete_function *MPICONSTANTS_NULL_DELETE_FN;
MPI_Errhandler MPICONSTANTS_ERRHANDLER_NULL;
MPI_Errhandler MPICONSTANTS_ERRORS_ARE_FATAL;
MPI_Errhandler MPICONSTANTS_ERRORS_RETURN;
MPI_File MPICONSTANTS_FILE_NULL;
MPI_Group MPICONSTANTS_GROUP_EMPTY;
MPI_Group MPICONSTANTS_GROUP_NULL;
#if MPI_VERSION >= 3
MPI_Info MPICONSTANTS_INFO_ENV;
#endif
MPI_Info MPICONSTANTS_INFO_NULL;
MPI_Message MPICONSTANTS_MESSAGE_NO_PROC;
MPI_Message MPICONSTANTS_MESSAGE_NULL;
MPI_Offset MPICONSTANTS_DISPLACEMENT_CURRENT;
MPI_Op MPICONSTANTS_BAND;
MPI_Op MPICONSTANTS_BOR;
MPI_Op MPICONSTANTS_BXOR;
MPI_Op MPICONSTANTS_LAND;
MPI_Op MPICONSTANTS_LOR;
MPI_Op MPICONSTANTS_LXOR;
MPI_Op MPICONSTANTS_MAX;
MPI_Op MPICONSTANTS_MAXLOC;
MPI_Op MPICONSTANTS_MIN;
MPI_Op MPICONSTANTS_MINLOC;
MPI_Op MPICONSTANTS_NO_OP;
MPI_Op MPICONSTANTS_OP_NULL;
MPI_Op MPICONSTANTS_PROD;
MPI_Op MPICONSTANTS_REPLACE;
MPI_Op MPICONSTANTS_SUM;
MPI_Request MPICONSTANTS_REQUEST_NULL;
MPI_Status *MPICONSTANTS_STATUS_IGNORE;
MPI_Status *MPICONSTANTS_STATUSES_IGNORE;
MPI_Type_copy_attr_function *MPICONSTANTS_TYPE_DUP_FN;
MPI_Type_copy_attr_function *MPICONSTANTS_TYPE_NULL_COPY_FN;
MPI_Type_delete_attr_function *MPICONSTANTS_TYPE_NULL_DELETE_FN;
MPI_Win MPICONSTANTS_WIN_NULL;
MPI_Win_copy_attr_function *MPICONSTANTS_WIN_DUP_FN;
MPI_Win_copy_attr_function *MPICONSTANTS_WIN_NULL_COPY_FN;
MPI_Win_delete_attr_function *MPICONSTANTS_WIN_NULL_DELETE_FN;

#ifdef __APPLE__
#define CONSTRUCTOR_PRIORITY
#else
#define CONSTRUCTOR_PRIORITY (1000)
#endif
static void __attribute__((__constructor__ CONSTRUCTOR_PRIORITY))
mpiconstants_init() {
  MPICONSTANTS_ANY_SOURCE = MPI_ANY_SOURCE;
  MPICONSTANTS_ANY_TAG = MPI_ANY_TAG;
  MPICONSTANTS_PROC_NULL = MPI_PROC_NULL;
  MPICONSTANTS_ROOT = MPI_ROOT;
  MPICONSTANTS_CART = MPI_CART;
  MPICONSTANTS_DIST_GRAPH = MPI_DIST_GRAPH;
  MPICONSTANTS_GRAPH = MPI_GRAPH;
  MPICONSTANTS_CONGRUENT = MPI_CONGRUENT;
  MPICONSTANTS_IDENT = MPI_IDENT;
  MPICONSTANTS_SIMILAR = MPI_SIMILAR;
  MPICONSTANTS_UNEQUAL = MPI_UNEQUAL;
  MPICONSTANTS_BSEND_OVERHEAD = MPI_BSEND_OVERHEAD;
  MPICONSTANTS_KEYVAL_INVALID = MPI_KEYVAL_INVALID;
  MPICONSTANTS_UNDEFINED = MPI_UNDEFINED;
  MPICONSTANTS_APPNUM = MPI_APPNUM;
  MPICONSTANTS_HOST = MPI_HOST;
  MPICONSTANTS_IO = MPI_IO;
  MPICONSTANTS_LASTUSEDCODE = MPI_LASTUSEDCODE;
  MPICONSTANTS_TAG_UB = MPI_TAG_UB;
  MPICONSTANTS_UNIVERSE_SIZE = MPI_UNIVERSE_SIZE;
  MPICONSTANTS_WIN_BASE = MPI_WIN_BASE;
  MPICONSTANTS_WIN_CREATE_FLAVOR = MPI_WIN_CREATE_FLAVOR;
  MPICONSTANTS_WIN_DISP_UNIT = MPI_WIN_DISP_UNIT;
  MPICONSTANTS_WIN_MODEL = MPI_WIN_MODEL;
  MPICONSTANTS_WIN_SIZE = MPI_WIN_SIZE;
  MPICONSTANTS_WTIME_IS_GLOBAL = MPI_WTIME_IS_GLOBAL;
  MPICONSTANTS_COMBINER_CONTIGUOUS = MPI_COMBINER_CONTIGUOUS;
  MPICONSTANTS_COMBINER_DARRAY = MPI_COMBINER_DARRAY;
  MPICONSTANTS_COMBINER_DUP = MPI_COMBINER_DUP;
  MPICONSTANTS_COMBINER_F90_COMPLEX = MPI_COMBINER_F90_COMPLEX;
  MPICONSTANTS_COMBINER_F90_INTEGER = MPI_COMBINER_F90_INTEGER;
  MPICONSTANTS_COMBINER_F90_REAL = MPI_COMBINER_F90_REAL;
  MPICONSTANTS_COMBINER_HINDEXED = MPI_COMBINER_HINDEXED;
  MPICONSTANTS_COMBINER_HINDEXED_BLOCK = MPI_COMBINER_HINDEXED_BLOCK;
  MPICONSTANTS_COMBINER_HVECTOR = MPI_COMBINER_HVECTOR;
  MPICONSTANTS_COMBINER_INDEXED = MPI_COMBINER_INDEXED;
  MPICONSTANTS_COMBINER_INDEXED_BLOCK = MPI_COMBINER_INDEXED_BLOCK;
  MPICONSTANTS_COMBINER_NAMED = MPI_COMBINER_NAMED;
  MPICONSTANTS_COMBINER_RESIZED = MPI_COMBINER_RESIZED;
  MPICONSTANTS_COMBINER_STRUCT = MPI_COMBINER_STRUCT;
  MPICONSTANTS_COMBINER_SUBARRAY = MPI_COMBINER_SUBARRAY;
  MPICONSTANTS_COMBINER_VECTOR = MPI_COMBINER_VECTOR;
  MPICONSTANTS_COMM_TYPE_SHARED = MPI_COMM_TYPE_SHARED;
  MPICONSTANTS_DISTRIBUTE_BLOCK = MPI_DISTRIBUTE_BLOCK;
  MPICONSTANTS_DISTRIBUTE_CYCLIC = MPI_DISTRIBUTE_CYCLIC;
  MPICONSTANTS_DISTRIBUTE_NONE = MPI_DISTRIBUTE_NONE;
  MPICONSTANTS_ERR_ACCESS = MPI_ERR_ACCESS;
  MPICONSTANTS_ERR_AMODE = MPI_ERR_AMODE;
  MPICONSTANTS_ERR_ARG = MPI_ERR_ARG;
  MPICONSTANTS_ERR_ASSERT = MPI_ERR_ASSERT;
  MPICONSTANTS_ERR_BAD_FILE = MPI_ERR_BAD_FILE;
  MPICONSTANTS_ERR_BASE = MPI_ERR_BASE;
  MPICONSTANTS_ERR_BUFFER = MPI_ERR_BUFFER;
  MPICONSTANTS_ERR_COMM = MPI_ERR_COMM;
  MPICONSTANTS_ERR_CONVERSION = MPI_ERR_CONVERSION;
  MPICONSTANTS_ERR_COUNT = MPI_ERR_COUNT;
  MPICONSTANTS_ERR_DIMS = MPI_ERR_DIMS;
  MPICONSTANTS_ERR_DISP = MPI_ERR_DISP;
  MPICONSTANTS_ERR_DUP_DATAREP = MPI_ERR_DUP_DATAREP;
  MPICONSTANTS_ERR_FILE = MPI_ERR_FILE;
  MPICONSTANTS_ERR_FILE_EXISTS = MPI_ERR_FILE_EXISTS;
  MPICONSTANTS_ERR_FILE_IN_USE = MPI_ERR_FILE_IN_USE;
  MPICONSTANTS_ERR_GROUP = MPI_ERR_GROUP;
  MPICONSTANTS_ERR_INFO = MPI_ERR_INFO;
  MPICONSTANTS_ERR_INFO_KEY = MPI_ERR_INFO_KEY;
  MPICONSTANTS_ERR_INFO_NOKEY = MPI_ERR_INFO_NOKEY;
  MPICONSTANTS_ERR_INFO_VALUE = MPI_ERR_INFO_VALUE;
  MPICONSTANTS_ERR_INTERN = MPI_ERR_INTERN;
  MPICONSTANTS_ERR_IN_STATUS = MPI_ERR_IN_STATUS;
  MPICONSTANTS_ERR_IO = MPI_ERR_IO;
  MPICONSTANTS_ERR_KEYVAL = MPI_ERR_KEYVAL;
  MPICONSTANTS_ERR_LASTCODE = MPI_ERR_LASTCODE;
  MPICONSTANTS_ERR_LOCKTYPE = MPI_ERR_LOCKTYPE;
  MPICONSTANTS_ERR_NAME = MPI_ERR_NAME;
  MPICONSTANTS_ERR_NOT_SAME = MPI_ERR_NOT_SAME;
  MPICONSTANTS_ERR_NO_MEM = MPI_ERR_NO_MEM;
  MPICONSTANTS_ERR_NO_SPACE = MPI_ERR_NO_SPACE;
  MPICONSTANTS_ERR_NO_SUCH_FILE = MPI_ERR_NO_SUCH_FILE;
  MPICONSTANTS_ERR_OP = MPI_ERR_OP;
  MPICONSTANTS_ERR_OTHER = MPI_ERR_OTHER;
  MPICONSTANTS_ERR_PENDING = MPI_ERR_PENDING;
  MPICONSTANTS_ERR_PORT = MPI_ERR_PORT;
  MPICONSTANTS_ERR_QUOTA = MPI_ERR_QUOTA;
  MPICONSTANTS_ERR_RANK = MPI_ERR_RANK;
  MPICONSTANTS_ERR_READ_ONLY = MPI_ERR_READ_ONLY;
  MPICONSTANTS_ERR_REQUEST = MPI_ERR_REQUEST;
#if MPI_VERSION >= 3
  MPICONSTANTS_ERR_RMA_ATTACH = MPI_ERR_RMA_ATTACH;
#endif
  MPICONSTANTS_ERR_RMA_CONFLICT = MPI_ERR_RMA_CONFLICT;
#if MPI_VERSION >= 3
  MPICONSTANTS_ERR_RMA_FLAVOR = MPI_ERR_RMA_FLAVOR;
  MPICONSTANTS_ERR_RMA_RANGE = MPI_ERR_RMA_RANGE;
  MPICONSTANTS_ERR_RMA_SHARED = MPI_ERR_RMA_SHARED;
#endif
  MPICONSTANTS_ERR_RMA_SYNC = MPI_ERR_RMA_SYNC;
  MPICONSTANTS_ERR_ROOT = MPI_ERR_ROOT;
  MPICONSTANTS_ERR_SERVICE = MPI_ERR_SERVICE;
  MPICONSTANTS_ERR_SIZE = MPI_ERR_SIZE;
  MPICONSTANTS_ERR_SPAWN = MPI_ERR_SPAWN;
  MPICONSTANTS_ERR_TAG = MPI_ERR_TAG;
  MPICONSTANTS_ERR_TOPOLOGY = MPI_ERR_TOPOLOGY;
  MPICONSTANTS_ERR_TRUNCATE = MPI_ERR_TRUNCATE;
  MPICONSTANTS_ERR_TYPE = MPI_ERR_TYPE;
  MPICONSTANTS_ERR_UNKNOWN = MPI_ERR_UNKNOWN;
  MPICONSTANTS_ERR_UNSUPPORTED_DATAREP = MPI_ERR_UNSUPPORTED_DATAREP;
  MPICONSTANTS_ERR_UNSUPPORTED_OPERATION = MPI_ERR_UNSUPPORTED_OPERATION;
  MPICONSTANTS_ERR_WIN = MPI_ERR_WIN;
  MPICONSTANTS_SUCCESS = MPI_SUCCESS;
  MPICONSTANTS_LOCK_EXCLUSIVE = MPI_LOCK_EXCLUSIVE;
  MPICONSTANTS_LOCK_SHARED = MPI_LOCK_SHARED;
  MPICONSTANTS_MODE_APPEND = MPI_MODE_APPEND;
  MPICONSTANTS_MODE_CREATE = MPI_MODE_CREATE;
  MPICONSTANTS_MODE_DELETE_ON_CLOSE = MPI_MODE_DELETE_ON_CLOSE;
  MPICONSTANTS_MODE_EXCL = MPI_MODE_EXCL;
  MPICONSTANTS_MODE_NOCHECK = MPI_MODE_NOCHECK;
  MPICONSTANTS_MODE_NOPRECEDE = MPI_MODE_NOPRECEDE;
  MPICONSTANTS_MODE_NOPUT = MPI_MODE_NOPUT;
  MPICONSTANTS_MODE_NOSTORE = MPI_MODE_NOSTORE;
  MPICONSTANTS_MODE_NOSUCCEED = MPI_MODE_NOSUCCEED;
  MPICONSTANTS_MODE_RDONLY = MPI_MODE_RDONLY;
  MPICONSTANTS_MODE_RDWR = MPI_MODE_RDWR;
  MPICONSTANTS_MODE_SEQUENTIAL = MPI_MODE_SEQUENTIAL;
  MPICONSTANTS_MODE_UNIQUE_OPEN = MPI_MODE_UNIQUE_OPEN;
  MPICONSTANTS_MODE_WRONLY = MPI_MODE_WRONLY;
  MPICONSTANTS_ORDER_C = MPI_ORDER_C;
  MPICONSTANTS_ORDER_FORTRAN = MPI_ORDER_FORTRAN;
  MPICONSTANTS_SEEK_CUR = MPI_SEEK_CUR;
  MPICONSTANTS_SEEK_END = MPI_SEEK_END;
  MPICONSTANTS_SEEK_SET = MPI_SEEK_SET;
  MPICONSTANTS_THREAD_SINGLE = MPI_THREAD_SINGLE;
  MPICONSTANTS_THREAD_FUNNELED = MPI_THREAD_FUNNELED;
  MPICONSTANTS_THREAD_SERIALIZED = MPI_THREAD_SERIALIZED;
  MPICONSTANTS_THREAD_MULTIPLE = MPI_THREAD_MULTIPLE;
  MPICONSTANTS_TYPECLASS_COMPLEX = MPI_TYPECLASS_COMPLEX;
  MPICONSTANTS_TYPECLASS_INTEGER = MPI_TYPECLASS_INTEGER;
  MPICONSTANTS_TYPECLASS_REAL = MPI_TYPECLASS_REAL;

  MPICONSTANTS_ARGV_NULL = MPI_ARGV_NULL;
  MPICONSTANTS_ARGVS_NULL = MPI_ARGVS_NULL;
  MPICONSTANTS_UNWEIGHTED = MPI_UNWEIGHTED;
  MPICONSTANTS_WEIGHTS_EMPTY = MPI_WEIGHTS_EMPTY;
  MPICONSTANTS_BOTTOM = MPI_BOTTOM;
  MPICONSTANTS_IN_PLACE = MPI_IN_PLACE;

  MPICONSTANTS_COMM_NULL = MPI_COMM_NULL;
  MPICONSTANTS_COMM_SELF = MPI_COMM_SELF;
  MPICONSTANTS_COMM_WORLD = MPI_COMM_WORLD;
  MPICONSTANTS_COMM_DUP_FN = MPI_COMM_DUP_FN;
  MPICONSTANTS_COMM_NULL_COPY_FN = MPI_COMM_NULL_COPY_FN;
  MPICONSTANTS_COMM_NULL_DELETE_FN = MPI_COMM_NULL_DELETE_FN;
  MPICONSTANTS_NULL_COPY_FN = MPI_NULL_COPY_FN;
  MPICONSTANTS_2DOUBLE_PRECISION = MPI_2DOUBLE_PRECISION;
  MPICONSTANTS_2INT = MPI_2INT;
  MPICONSTANTS_2INTEGER = MPI_2INTEGER;
  MPICONSTANTS_2REAL = MPI_2REAL;
  MPICONSTANTS_AINT = MPI_AINT;
  MPICONSTANTS_BYTE = MPI_BYTE;
  MPICONSTANTS_CHAR = MPI_CHAR;
  MPICONSTANTS_CHARACTER = MPI_CHARACTER;
  MPICONSTANTS_COMPLEX = MPI_COMPLEX;
  MPICONSTANTS_COMPLEX16 = MPI_COMPLEX16;
#ifdef MPI_COMPLEX32
  MPICONSTANTS_COMPLEX32 = MPI_COMPLEX32;
#endif
  MPICONSTANTS_COMPLEX8 = MPI_COMPLEX8;
  MPICONSTANTS_COUNT = MPI_COUNT;
#if MPI_VERSION >= 3
  MPICONSTANTS_CXX_BOOL = MPI_CXX_BOOL;
  MPICONSTANTS_CXX_DOUBLE_COMPLEX = MPI_CXX_DOUBLE_COMPLEX;
  MPICONSTANTS_CXX_FLOAT_COMPLEX = MPI_CXX_FLOAT_COMPLEX;
  MPICONSTANTS_CXX_LONG_DOUBLE_COMPLEX = MPI_CXX_LONG_DOUBLE_COMPLEX;
#endif
  MPICONSTANTS_C_BOOL = MPI_C_BOOL;
  MPICONSTANTS_C_COMPLEX = MPI_C_COMPLEX;
  MPICONSTANTS_C_DOUBLE_COMPLEX = MPI_C_DOUBLE_COMPLEX;
  MPICONSTANTS_C_FLOAT_COMPLEX = MPI_C_FLOAT_COMPLEX;
  MPICONSTANTS_C_LONG_DOUBLE_COMPLEX = MPI_C_LONG_DOUBLE_COMPLEX;
  MPICONSTANTS_DATATYPE_NULL = MPI_DATATYPE_NULL;
  MPICONSTANTS_DOUBLE = MPI_DOUBLE;
  MPICONSTANTS_DOUBLE_COMPLEX = MPI_DOUBLE_COMPLEX;
  MPICONSTANTS_DOUBLE_INT = MPI_DOUBLE_INT;
  MPICONSTANTS_DOUBLE_PRECISION = MPI_DOUBLE_PRECISION;
  MPICONSTANTS_FLOAT = MPI_FLOAT;
  MPICONSTANTS_FLOAT_INT = MPI_FLOAT_INT;
  MPICONSTANTS_INT = MPI_INT;
  MPICONSTANTS_INT16_T = MPI_INT16_T;
  MPICONSTANTS_INT32_T = MPI_INT32_T;
  MPICONSTANTS_INT64_T = MPI_INT64_T;
  MPICONSTANTS_INT8_T = MPI_INT8_T;
  MPICONSTANTS_INTEGER = MPI_INTEGER;
  MPICONSTANTS_INTEGER1 = MPI_INTEGER1;
  MPICONSTANTS_INTEGER2 = MPI_INTEGER2;
  MPICONSTANTS_INTEGER4 = MPI_INTEGER4;
  MPICONSTANTS_INTEGER8 = MPI_INTEGER8;
  MPICONSTANTS_LOGICAL = MPI_LOGICAL;
  MPICONSTANTS_LONG = MPI_LONG;
  MPICONSTANTS_LONG_DOUBLE = MPI_LONG_DOUBLE;
  MPICONSTANTS_LONG_DOUBLE_INT = MPI_LONG_DOUBLE_INT;
  MPICONSTANTS_LONG_INT = MPI_LONG_INT;
  MPICONSTANTS_LONG_LONG = MPI_LONG_LONG;
  MPICONSTANTS_LONG_LONG_INT = MPI_LONG_LONG_INT;
  MPICONSTANTS_OFFSET = MPI_OFFSET;
  MPICONSTANTS_PACKED = MPI_PACKED;
  MPICONSTANTS_REAL = MPI_REAL;
#ifdef MPI_REAL16
  MPICONSTANTS_REAL16 = MPI_REAL16;
#endif
  MPICONSTANTS_REAL4 = MPI_REAL4;
  MPICONSTANTS_REAL8 = MPI_REAL8;
  MPICONSTANTS_SHORT = MPI_SHORT;
  MPICONSTANTS_SHORT_INT = MPI_SHORT_INT;
  MPICONSTANTS_SIGNED_CHAR = MPI_SIGNED_CHAR;
  MPICONSTANTS_UINT16_T = MPI_UINT16_T;
  MPICONSTANTS_UINT32_T = MPI_UINT32_T;
  MPICONSTANTS_UINT64_T = MPI_UINT64_T;
  MPICONSTANTS_UINT8_T = MPI_UINT8_T;
  MPICONSTANTS_UNSIGNED = MPI_UNSIGNED;
  MPICONSTANTS_UNSIGNED_CHAR = MPI_UNSIGNED_CHAR;
  MPICONSTANTS_UNSIGNED_LONG = MPI_UNSIGNED_LONG;
  MPICONSTANTS_UNSIGNED_LONG_LONG = MPI_UNSIGNED_LONG_LONG;
  MPICONSTANTS_UNSIGNED_SHORT = MPI_UNSIGNED_SHORT;
  MPICONSTANTS_WCHAR = MPI_WCHAR;
  MPICONSTANTS_NULL_DELETE_FN = MPI_NULL_DELETE_FN;
  MPICONSTANTS_ERRHANDLER_NULL = MPI_ERRHANDLER_NULL;
  MPICONSTANTS_ERRORS_ARE_FATAL = MPI_ERRORS_ARE_FATAL;
  MPICONSTANTS_ERRORS_RETURN = MPI_ERRORS_RETURN;
  MPICONSTANTS_FILE_NULL = MPI_FILE_NULL;
  MPICONSTANTS_GROUP_EMPTY = MPI_GROUP_EMPTY;
  MPICONSTANTS_GROUP_NULL = MPI_GROUP_NULL;
#if MPI_VERSION >= 3
  MPICONSTANTS_INFO_ENV = MPI_INFO_ENV;
#endif
  MPICONSTANTS_INFO_NULL = MPI_INFO_NULL;
  MPICONSTANTS_MESSAGE_NO_PROC = MPI_MESSAGE_NO_PROC;
  MPICONSTANTS_MESSAGE_NULL = MPI_MESSAGE_NULL;
  MPICONSTANTS_DISPLACEMENT_CURRENT = MPI_DISPLACEMENT_CURRENT;
  MPICONSTANTS_BAND = MPI_BAND;
  MPICONSTANTS_BOR = MPI_BOR;
  MPICONSTANTS_BXOR = MPI_BXOR;
  MPICONSTANTS_LAND = MPI_LAND;
  MPICONSTANTS_LOR = MPI_LOR;
  MPICONSTANTS_LXOR = MPI_LXOR;
  MPICONSTANTS_MAX = MPI_MAX;
  MPICONSTANTS_MAXLOC = MPI_MAXLOC;
  MPICONSTANTS_MIN = MPI_MIN;
  MPICONSTANTS_MINLOC = MPI_MINLOC;
  MPICONSTANTS_NO_OP = MPI_NO_OP;
  MPICONSTANTS_OP_NULL = MPI_OP_NULL;
  MPICONSTANTS_PROD = MPI_PROD;
  MPICONSTANTS_REPLACE = MPI_REPLACE;
  MPICONSTANTS_SUM = MPI_SUM;
  MPICONSTANTS_REQUEST_NULL = MPI_REQUEST_NULL;
  MPICONSTANTS_STATUS_IGNORE = MPI_STATUS_IGNORE;
  MPICONSTANTS_STATUSES_IGNORE = MPI_STATUSES_IGNORE;
  MPICONSTANTS_TYPE_DUP_FN = MPI_TYPE_DUP_FN;
  MPICONSTANTS_TYPE_NULL_COPY_FN = MPI_TYPE_NULL_COPY_FN;
  MPICONSTANTS_TYPE_NULL_DELETE_FN = MPI_TYPE_NULL_DELETE_FN;
  MPICONSTANTS_WIN_NULL = MPI_WIN_NULL;
  MPICONSTANTS_WIN_DUP_FN = MPI_WIN_DUP_FN;
  MPICONSTANTS_WIN_NULL_COPY_FN = MPI_WIN_NULL_COPY_FN;
  MPICONSTANTS_WIN_NULL_DELETE_FN = MPI_WIN_NULL_DELETE_FN;
}
